<?php
// +----------------------------------------------------------------------+
// | Author:  Evgeny Leontev <eleontev@ezactive.com>                      |
// | Copyright (c) 2005 Evgeny Leontev                                    |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+

require_once 'eleontev/URL/RequestDataUtil.php';


class RequestData
{
	
	var $int_keys = array();
	var $skip_keys = array();	
	var $html_values = array();
	var $wordrap_num = 50;
	
	
	
	// array: key is that we can access it, value is custom real param
	// for example: real $_GET['custom'] = 20; we can access it like $rq->action, 
	// so on page we always can write $rq->action
	// access any var we want just change value for $predefined array for that key
	//var $predefined = array('action'=>'_a');
	var $predefined = array();
	var $vars = array();
	
	var $action; // to have it on page
	
	
	function RequestData(&$var) {
		$this->setVars($var);
	}
	
	
	function setIntKeys($key) {
		$this->int_keys[] = $key;
	}	
	
	function setSkipKeys($key) {
		$this->skip_keys[] = $key;
	}
	
	
	function setHtmlValues($key) {
		$this->html_values[$key] = &$this->vars[$key];
	}	
	
	
	function setVars(&$var) {
		
		//if(!checkPHP()) { // check for php 5.2.0
			$this->setVarsPHP4($var);
		//}
		
		$this->vars =& $var;
		$this->toInt();
	}
	
	
	// I do not like it at all
	function setVarsPHP4(&$arr) {
		foreach($arr as $k => $v){
			$this->$k =& $arr[$k];
		}
	}
	
	
/*
	function __set($nm, $val) { //print "Setting [$nm] to $val\n<br>"; 
		if(isset($this->predefined[$nm])) {
			$this->vars[$this->predefined[$nm]] = $val; 
		} else {
			$this->vars[$nm] = $val; 
		}
	}
	
	
	function __get($nm) { //print "Getting [$nm]\n<br>"; 
		if(isset($this->predefined[$nm])) {
			$t = $this->vars[$this->predefined[$nm]]; 
		} elseif (isset($this->vars[$nm])) {
			$t = $this->vars[$nm]; 
		}
		
		if($t === false) {
			return $t; 
		} else {
			echo "Undefined property <b>$nm</b>";
			//echo __FILE__ . '(' . __LINE__ . ')' . __METHOD__; 
		}
	} 
*/
	
	 
	function toInt() {
		return RequestDataUtil::toInt($this->vars, $this->int_keys);
	}
	
	
	//function toSafe() {
	//	return RequestDataUtil::toSafe($this->vars, $this->int_values);
	//}
	
	
	function stripVars($server_check = false) {
		
		$_ar = array_merge($this->skip_keys, array_keys($this->html_values));
		
		RequestDataUtil::stripVars($this->vars, $_ar, $server_check, $this->wordrap_num);
		RequestDataUtil::stripVarsHtml($this->html_values, array(), $server_check);
	}
	
	
	//function stripVarsHtml($server_check = false) {
	//	return RequestDataUtil::stripVarsHtml($this->vars, $this->skip_values, $server_check);
	//}
}



class FilterRequestData
{

	var $filters = array();
	
	
	function setFilter($func_name) {
		$this->filters[] = $func_name;
	}	
	
	
	
}

//$rq =& new RequestData($_GET);
//echo $rq->action;

///$rq->setVars($_POST);
//$rq->id = 58;
//echo $rq->my_name[15];

//$rq->stripVars();


//$rq->my = array(15);
//echo $rq->my;

//echo "<pre>"; print_r($rq); echo "</pre>";
//echo "<pre>"; print_r($_GET); echo "</pre>";
?>
