<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+


require_once 'config.inc.php';
require_once 'common.inc.php';

session_unset();

$db =& DBUtil::connect($conf);
$reg =& Registry::instance();
$reg->setEntry('db', $db);
$reg->setEntry('tbl_pref', $conf['tbl_pref']);


$auth = false;
$do_login = false;

if (isset($_POST['login_username']) && isset($_POST['login_password'])) { 

	$priv = &new AuthPriv();
	$auth = $priv->doAuth($_POST['login_username'], $_POST['login_password']);
	$do_login = true;
} 


if ($auth == false) {
	//sleep(1); // for brute attack, not sure
	
	$tpl = new tplTemplatez(APP_TMPL_DIR . 'login.html');
	$tpl->tplAssign('meta_charset', $conf['lang']['meta_charset']);
	
	if($do_login) {
		$file = AppMsg::getCommonMsgFile('error_msg.ini');
		$msgs =& AppMsg::parseMsgs($file, 'login_failed');		
		
		$tpl->tplAssign('error_msg', BoxMsg::factory('error', $msgs));
	}
	
	if(APP_DEMO_MODE) {
		$tpl->tplSetNeeded('/demo');
	}
	
	$tpl->tplAssign(AppMsg::getMsgs('common_msg.ini'));
	
	$tpl->tplParse($_POST);
	$tpl->tplPrint();

} else {
	
	header('Location: ' . APP_HOME_PATH . 'go.php');
	exit();
}
?>
