<?
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once 'eleontev/HTML/FormSelect.php' ;
require_once APP_MODULE_DIR . 'setting/inc/SettingModel.php';


class KBCategoryView_form extends AppView
{
	
	var $tmpl = 'form.html';
	
	
	function execute(&$obj, &$manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . $this->tmpl);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		$rows = &$manager->getSelectRecords();
		$range = &$manager->getSelectRange($rows);
		$js_values =& $manager->getSortJsArray($rows);
		
		foreach($js_values as $k => $v) {
			$a['js_option_list_values'] = $v;
			
			$key = ($obj->get('id')) ? $obj->get('sort_order') : 'sort_end';
			$a['js_option_default'] = sprintf("'%s', '%s'", $k, $key);
			$tpl->tplParse($a, 'js_option_list');
		}		
		
		
		$select = new FormSelect();
		$select->setSelectWidth(250);
		
		$select->select_tag = false;
		
		// set disabled for self
		if($obj->get('id')) { 
			$select->setOptionDisabled($obj->get('id')); 
		} 
		
		$select->setMultiple(5, false);
		$select->setSelectName('parent_id');
		$select->setRange($range, array(0=>$this->msg['top_level_msg']));
		$tpl->tplAssign('category_select', $select->select($obj->get('parent_id')));
		
		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		//$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));
		
		
		$s = &new SettingModel;
		$s->module_id = 100; 
		$setting = &$s->getSettings();
		//echo "<pre>"; print_r($setting); echo "</pre>";
		
		if($setting['allow_comments']) { $var =  $this->getChecked($obj->get('commentable')); } 
		else                           { $var = 'disabled'; }
		$tpl->tplAssign('commentable_options', $var);

		if($setting['allow_rating'])   { $var =  $this->getChecked($obj->get('ratingable')); } 
		else                           { $var = 'disabled'; }
		$tpl->tplAssign('ratingable_options', $var);		
		
		
		$tpl->tplAssign('private_ch', $this->getChecked($obj->get('private')));
		
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}	
}
?>
