<?
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBCategoryView_list extends AppView
{
        
	var $tmpl = 'list.html';
	var $padding = 20;
	
	
	function execute(&$obj, &$manager) {
	
		$tpl = &new tplTemplatez($this->template_dir . $this->tmpl);
		
		// sort generate
		//$sort = new TwoWaySort();
		$sort = new OneWaySort($_GET);
		$sort->default_order = 1;
		$sort->setTitleMsg('asc',  $this->msg['sort_asc_msg']);
		$sort->setTitleMsg('desc', $this->msg['sort_desc_msg']);
		$sort->setSortItem('name_msg',  'name', 'name', $this->msg['name_msg']);
		$sort->setSortItem('private_msg', 'private', 'private', $this->msg['private_msg']);
		$sort->setSortItem('status_msg','status', 'active', $this->msg['status_msg']);
		$sort->setSortItem('entries_msg','num', 'num_entries', $this->msg['entries_msg']);
		$sort->setSortItem('sort_order_msg','sort_order', 'sort_order', $this->msg['sort_order_msg'], 1);
		
		
		// header generate
		$tpl->tplAssign('header', $this->commonHeaderList());
		
		// get records
		$manager->setSqlParamsOrder($sort->getSql());
		$rows = &$manager->getRecords();
		$tree_helper = &$manager->getTreeHelperArray($rows);
		//$entry_per_cat = &$manager->getNumEntriesPerCategory();
		
		foreach($tree_helper as $cat_id => $level) {
		
		//$parents = &TreeHelperUtil::getParentsById($rows, $cat_id);
		//echo "<pre>"; print_r($parents); echo "</pre>";
		$v = $this->getViewListVars($cat_id, null, $rows[$cat_id]['parent_id'] );
		
		//$v = $this->getViewListVars($cat_id, null, $cat_id);
		
		$v['num_entries'] = ($rows[$cat_id]['num_entries']) ? $rows[$cat_id]['num_entries'] : '';
		$v['entry_link'] = $_SERVER['PHP_SELF'] . '?module=knowledgebase&page=kb_entry&filter=' .$cat_id;
		
		//$v['private_short_msg'] = ($rows[$cat_id]['private']) ? $this->msg['yes_msg'] 
		//                                                      : $this->msg['no_msg'];
		
		//if($rows[$cat_id]['private']) {
		//      $tpl->tplSetNeeded('row/if_private');
		//}
		
		if($rows[$cat_id]['commentable']) {
			$tpl->tplSetNeeded('row/if_commentable');
		}
		
		if($rows[$cat_id]['ratingable']) {
			$tpl->tplSetNeeded('row/if_ratingable');
		}                               
		
		
		$v['class'] = ($level == 0) ? 'trDarker' : 'trLighter';
		$v['padding'] = $this->padding*$level;
		$block = ($level == 0) ? 'level_0' : 'other_level';
		
		$tpl->tplSetNeeded('row/' . $block);
			$tpl->tplParse(array_merge($v, $rows[$cat_id], $this->msg), 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($sort->toHtml());
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	
	// reassign for use with parents
	// used it to set links such as delete, update
	function getViewListVars($record_id = false, $active = NULL, $parent_id = false) {
		
		$row = &parent::getViewListVars($record_id, $active);
		
		$link = $this->controller->getCommonLink();
		$action = $this->controller->getAction();
		
		// insert
		$row['insert_link'] = sprintf('%s&action=insert&parent_id=%d', $link, $record_id);
		$row['insert_img'] = $this->getImgLink($row['insert_link'], 'doc_icon', $this->msg['new_child_category_msg']);
		
		//delete
		$row['delete_link'] = sprintf('%s&action=delete&id=%d&parent_id=%d', $link, $record_id, $parent_id);
		$row['delete_img'] = $this->getImgLink($row['delete_link'], 'delete', $this->msg['delete_msg'], $this->msg['sure_delete_category_msg']);                
		
		return $row;
	}
	
	
	
/*
	// reassign for use with parents
	// used it to set links such as delete, update
	function getViewListVars($record_id = false, 
							 $parent_id = false,
							 $active = NULL, 
							 $parents = array()) {
		
		static $i = 0;
		static $inactive = array();
		
		
		$link = $this->controller->getCommonLink();
		$action = $this->controller->getAction();

		//$row['class'] = ($i++ & 1) ? 'trDarker' : 'trLighter'; // rows colors
		
		$row['style'] = ($active !== null && !$active) ? $this->inactive_style : ''; // style for not active
		$row['add_link'] = sprintf('%s&%s=insert', $link, $action);
		
		
		$active_var = ($active == 0) ? '1' : '0';
		$active_img = ($active == 0) ? 'active_0' : 'active_1';
		$_active_link = sprintf('%s&%s=status&id=%d&status=%d', $link, $action, $record_id, $active_var);
		$_active_img = $this->getImgLink($_active_link, $active_img, $this->msg['set_status_msg'], $this->msg['sure_status_msg']);
				
		
		// active link
		if($active == 0) {
			$inactive[$record_id] = $record_id;
			
		} else {
			foreach($parents as $id) {
				if(in_array($id, $inactive)) {
				
					$_active_link = '';
					//$_active_img = 'images/icons/active_d_0.gif';
					$_active_img = $this->getImgLink('', 'active_d_0', ''); // jusr disabled checkbox img
			
				} //else {
					//$active_link = sprintf('%s&%s=status&id=%d&status=%d', $link, $action, $record_id, $active_var);
					//$active_img = $this->getImgLink($row['active_link'], $active_img, $this->msg['set_status_msg'], 'Sure?');
				//}
			}
		}
		
		
		$row['active_link'] = $_active_link;
		$row['active_img'] = $_active_img;
				
		
		//$active_var = ($active == 0) ? '1' : '0';
		//$active_img = ($active == 0) ? 'active_0' : 'active_1';
		//$row['active_link'] = sprintf('%s&%s=status&id=%d&status=%d', $link, $action, $record_id, $active_var);
		//$row['active_img'] = $this->getImgLink($row['active_link'], $active_img, $this->msg['set_status_msg'], 'Sure?');
		
		// insert
		//$row['insert_link'] = sprintf('%s&%s=insert&parent_id=%d', $link, $action, $parent_id);
		$row['insert_link'] = sprintf('%s&%s=insert&parent_id=%d', $link, $action, $record_id);
		$row['insert_img'] = $this->getImgLink($row['insert_link'], 'doc_icon', $this->msg['add_new_msg']);
		
		// update
		$row['update_link'] = sprintf('%s&%s=update&id=%d&parent_id=%d', $link, $action, $record_id, $parent_id);
		$row['update_img'] = $this->getImgLink($row['update_link'], 'update', $this->msg['update_msg']);
		
		// delete
		$row['delete_link'] = sprintf('%s&%s=delete&id=%d&parent_id=%d', $link, $action, $record_id, $parent_id);
		$row['delete_img']	= $this->getImgLink($row['delete_link'], 'delete', $this->msg['delete_msg'], $this->msg['sure_delete_msg']);
		
		return $row;
	}
*/
}
?>
