<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+


require_once 'eleontev/Dir/Uploader.php';
require_once $controller->working_dir . 'inc/KBEntry.php';
require_once $controller->working_dir . 'inc/KBEntryModel.php';

//$priv->setCustomAction('upload', 'update');
//$priv->setCustomAction('update_file', 'update');
//$priv->setCustomAction('delete_file', 'delete');


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);
$rp->setHtmlValues('body'); // to skip $_GET['body'] not strip html

$obj = new KBEntry;

$manager =& $obj->setManager(new KBEntryModel());
//$manager->max_attachment_size = $conf['max_attachment_size'];
//$manager->attachment_dir = $conf['attachment_dir'];
//$manager->attachment_path = $conf['attachment_path'];

$manager->checkPriv($priv, $controller->action, @$rq->id);

switch ($controller->action) {
case 'delete': // ------------------------------
	 
	$manager->delete($rq->id);
	$controller->go();

	break;
	

case 'status': // ------------------------------
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;

	
case 'update': // ------------------------------
case 'insert': // ------------------------------

	
	if(isset($rp->submit) || isset($rp->submit_upload)) {
		
		$is_error =& $obj->validate($rp->vars);
		
		if($is_error) {
			$rp->stripVars(true);
			
			$obj->set($rp->vars);
			$obj->setCategory(@$rp->vars['category']);
			
			if(!empty($rp->vars['attachment'])) {
				$ids = implode(',', $rp->vars['attachment']);	
				$obj->setAttachment($manager->getAttachmentByAttachmentId($ids));
			}
					
		} else {
			$rp->stripVars();
			
			$obj->set($rp->vars);
			$obj->setCategory($rp->vars['category']);
			$obj->setAttachment(@$rp->vars['attachment']);
			
			$manager->save($obj);
			
			$controller->go();
		}
		
	
	} elseif($controller->action == 'update') {
		
		$obj->set($manager->getById($rq->id));
		$obj->setCategory($manager->getCategoryById($rq->id));
		
		//if($this->use_attachment) {
		//	$obj->setAttachment($manager->getAttachmentById($rq->id));
		//}
	}
	
	$view = &$controller->getView($obj, $manager, 'KBEntryView_form'); 

	break;
	

default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'KBEntryView_list');
}
?>