<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once APP_ROOT_DIR . 'tools/FCKeditor/fckeditor.php';
require_once 'eleontev/HTML/FormSelect.php';


class KBEntryView_form extends AppView
{
	
	var $template = 'form.html';
	
	function execute(&$obj, &$manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		
		$oFCKeditor = new FCKeditor('body');
		
		if(!$oFCKeditor->IsCompatible()) {
			$this->controller->go('editor_incompatible', true);
		}
		
		$oFCKeditor->BasePath = APP_HOME_PATH . 'tools/FCKeditor/';
		$oFCKeditor->ToolbarSet = 'Knowledgebase';		
		$oFCKeditor->Width  = '100%' ;
		$oFCKeditor->Height = '300' ;
		$oFCKeditor->Value	= &$obj->get('body');	
		
		$tpl->tplAssign('vck_editor', $oFCKeditor->CreateHtml());		
		
		//attachment
		foreach($obj->getAttachment() as $id => $filename) {
			$data = array('attachment_id'=>$id, 'filename'=>$filename);
			$data['delete_msg'] = $this->msg['delete_msg'];
			$tpl->tplParse($data, 'attachment_row');
		}
		
		
		// categories
		$select = new FormSelect();
		$select->setSelectWidth(250);
		//$select->select_tag = false;
		$select->setMultiple(8, true);
		$select->setSelectName('category');
		$select->setRange($manager->getCategorySelectRange());
		$tpl->tplAssign('category_select', $select->select($obj->getCategory()));

		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
}
?>