<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once $controller->working_dir . 'inc/Member.php';
require_once $controller->working_dir . 'inc/MemberModel.php';


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new Member;

$manager =& $obj->setManager(new MemberModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);


switch ($controller->action) {
case 'delete': // ------------------------------
	
	$manager->delete($rq->id);
	$controller->go();
	
	break;
	

case 'status': // ------------------------------
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	
	
case 'update': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars, $manager);
		
		if($is_error) {
			$rp->stripVars(true);	
			$obj->set($rp->vars);
			
		} else {
			$rp->stripVars();
			
			$obj->setPassword($rp->not_change_pass); // mean not insert in db if not_change_pass = 1
			$obj->set($rp->vars);
			
			$manager->save($obj);
			
			$controller->go();
		}
		
	} else {
		
		$obj->set($manager->getById($rq->id));
	}

	$view = &$controller->getView($obj, $manager, 'MemberView_form');

	break;
	
	
	
case 'insert': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars, $manager);
		
		if($is_error) {
			$rp->stripVars(true);
			$obj->set($rp->vars);
			
		} else {
			$rp->stripVars();
			$obj->set($rp->vars);
			
			$manager->save($obj);
			
			$controller->go();
		}
	}

	$view = &$controller->getView($obj, $manager, 'MemberView_form');
	
	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'MemberView_list');
}
?>