<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once $controller->working_dir . 'inc/User.php';
require_once $controller->working_dir . 'inc/UserModel.php';



// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new User;
$obj->is_admin = (isset($_SESSION['priv_']['all']));

$manager =& $obj->setManager(new UserModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);



require_once 'eleontev/HTML/BoxMsg.php';
$msgs = array('title'=>'OPERATION IS NOT ALLOWED IN DEMO VERSION!', 
              'body' =>'You do not have enough permissions for this operation or access this module.<br>
			            <b>&laquo; <a href="javascript:history.back(1)">back</a></b>');



switch ($controller->action) {
case 'delete': // ------------------------------
	
	if(APP_DEMO_MODE == true) { exit(BoxMsg::factory('error', $msgs)); }
	
	$manager->delete($rq->id);
	$controller->go();
	
	break;
	

case 'status': // ------------------------------
	
	if(APP_DEMO_MODE == true) { exit(BoxMsg::factory('error', $msgs)); }	
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	
	
case 'update': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars, $manager);
		
		if($is_error) {
			$rp->stripVars(true);
			
			$obj->set($rp->vars);
			$obj->setPriv(@$rp->vars['priv']);
			
		
		} else {
			$rp->stripVars();
			
			$obj->setPassword($rp->not_change_pass); // mean not insert in db if not_change_pass = 1
			$obj->set($rp->vars);
			$obj->setPriv(@$rp->vars['priv']);
			
			if(APP_DEMO_MODE == true) { exit(BoxMsg::factory('error', $msgs)); }	
			
			$manager->save($obj);
			$controller->go();
		}
		
	} else {
		
		$obj->set($manager->getById($rq->id));
		$obj->setPriv($manager->getPrivById($rq->id));
	}

	$view = &$controller->getView($obj, $manager, 'UserView_form');

	break;
	
	
	
case 'insert': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars, $manager);
		
		if($is_error) {
			$rp->stripVars(true);
			
			$obj->set($rp->vars);
			$obj->setPriv(@$rp->vars['priv']);
			
			
		} else {
			$rp->stripVars();
			
			$obj->set($rp->vars);
			$obj->setPriv(@$rp->vars['priv']);
			
			if(APP_DEMO_MODE == true) { exit(BoxMsg::factory('error', $msgs)); }	
			
			$manager->save($obj);
			$controller->go();
		}
	}

	$view = &$controller->getView($obj, $manager, 'UserView_form');
	
	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'UserView_list');
}
?>