<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientController
{
	var $query 		= array('view'        =>'View',
                            'category_id' =>'CategoryID',
				  	        'entry_id'    =>'EntryID',
					        'msg'  		  =>'Msg'
				   		    );
	
	var $request;
	
	var $working_dir;
	var $working_path;	
	var $mod_rewrite = false;
	var $mod_rewrite_page;
	var $setting = array();
	
	
	
	function KBClientController() {
	
		$this->mod_rewrite_page = substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/')) . '/';
		//$this->mod_rewrite_page = substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '.')) . '/';
	}
	
	
	function setSettings(&$settings) {
		$this->setting = &$settings;
	}
	
	
	function getSetting($setting_key) {
		return @$this->setting[$setting_key];
	}
	
	
	function setModRewrite($var) {
		$this->mod_rewrite = $var;
	}
	
	
	function getRequestVar($var) {
		return @$_GET[$this->query[$var]];
	}
	
	
	function getRequestKey($key) {
		return @$this->query[$key];
	}
	
	
	function getLink($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		if($view == 'all') {
			return $this->_getLink($this->getRequestVar('view'), 
			                              $this->getRequestVar('category_id'), 
										  $this->getRequestVar('entry_id'), 
										  $this->getRequestVar('msg')); 	
		} else {
			return $this->_getLink($view, $category_id, $entry_id, $msg_key);
		}
	}	
	
	
	function go($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		$url = $this->getLink($view, $category_id, $entry_id, $msg_key);
		header("Location: " . $url);
		exit();
	}
	
	
	function _getLink($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		
		if(!$this->mod_rewrite) {
		
			if($view)        { $link[1] = sprintf('%s=%s', $this->getRequestKey('view'), $view); }
			if($category_id) { $link[2] = sprintf('%s=%d', $this->getRequestKey('category_id'), $category_id); }
			if($entry_id)    { $link[3] = sprintf('%s=%d', $this->getRequestKey('entry_id'), $entry_id); }
			if($msg_key)     { $link[4] = sprintf('%s=%s', $this->getRequestKey('msg'), $msg_key); }			
			
			$link = (@!$link) ? $_SERVER['PHP_SELF'] : $_SERVER['PHP_SELF'] . '?' . implode('&', $link);
		
		} else {
		
			if($view)        { $link[1] = sprintf('%s', $view); }
			if($category_id) { $link[2] = sprintf('%d', $category_id); }
			if($entry_id)    { $link[3] = sprintf('%d', $entry_id); }
			if($msg_key)     { $link[4] = sprintf('%s', $msg_key); }
			
			$link = (@!$link) ? $this->mod_rewrite_page : $this->mod_rewrite_page . implode('/', $link) . '/';
		}
		
		return $link;
	}
	
}
?>