<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientPageRenderer extends PageRenderer
{
		
	
    function KBClientPageRenderer(&$view, &$manager, &$conf) {
		$this->setCommonVars($view, $manager, $conf);
    }

	
	function setCommonVars(&$view, &$manager, &$conf) {
        $this->view = &$view;
		$this->manager = &$manager;
		$this->vars['base_href'] = $this->view->conf['client_home_path'];
		//$this->conf = &$conf;		
	}
	
	
	 function render() {
		 
		if($this->isOnePageTemplate()) {
			
			$tpl = &new tplTemplatez($this->getTemplate());
			
			$data['content'] = &$this->view->execute($this->manager);
			$data['content'] .= $this->getCopyright();
			$data['style_css'] = $this->getStyleCss();		
			$data['meta_title'] = $this->getMetaTitle();
			$data['meta_charset'] = $this->getMetaCharset();
			$data['meta_robots'] = $this->getMetaRobots($this->view->view_id);
			//echo "<pre>"; print_r($this->view); echo "</pre>";
	
			$tpl->tplParse(array_merge($this->vars, $data));
			return $tpl->tplPrint(1);			
		
		} else {

			$page = $this->getHeaderFooter();
			
			include_once $page[0];
			echo '<link rel="STYLESHEET" type="text/css" href="'.$this->getStyleCss().'">' . "\n";
			echo $this->view->execute($this->manager);
			echo $this->getCopyright();
			include_once $page[1];
		}
	}
	
	
	function isOnePageTemplate() {
		return (strpos($this->manager->setting['page_to_load'], ';') === false);
	}
	
	
	function getHeaderFooter() {
		$ar = explode(';', $this->manager->setting['page_to_load']);
		$ar[0] = trim($ar[0]);
		$ar[1] = trim($ar[1]);
		
		return $ar;
	}
	
	
	function getTemplate() {
		if(strtolower($this->manager->setting['page_to_load']) == 'default') {
			$page = $this->view->template_dir . 'page.html'; 
		} else {
			$page = $this->manager->setting['page_to_load'];
		}
		
		return $page;
	}
	
	
	// set title of page
	function getMetaTitle() {
		
		$data = array();
		if($this->manager->getSetting('site_title')) {
			$data[] = $this->manager->getSetting('site_title');
		}
		
		//$data[] = $this->view->msg['kb_home_title'];
		
		if($this->view->meta_title) {
			$data[] = $this->view->meta_title;
		}
		
		return implode($this->title_delim, $data);
	}
	
	
	function getMetaRobots($view) {
		
		// array with view keys for what we use 
		//<meta name="robots" content="all">
		$all_arr = array('', 'entry', 'glossary');
		$meta_robots = 'NONE';
		
		if(in_array($view, $all_arr)) {
			$meta_robots = 'ALL';
		} 
		
		return $meta_robots;
	}
	
	
	function getMetaCharset() {
		//return 'iso-8859-1';
		//return 'utf-8';
		//return $this->meta_charset;
		return $this->view->conf['lang']['meta_charset'];
	}
	
	
	function getCopyright() {
		$str = '<br><br><hr size="1" noshade>
				<span class="copyright">
				%s <a href="%s">%s</a>
				</span>';
		
		return sprintf($str, $this->view->msg['powered_by_msg'], 
		                     $this->view->conf['product_www'], 
							 //$this->conf['product_name'] . ' ' .
							 'KnowledgebasePublisher' . ' ' .
							 $this->view->conf['product_version']
							 );
	}
	
	
	function getStyleCss() {
		return $this->view->style_css;
	}
	
	
	function display() {
		echo $this->render();
	}
}
?>