<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientView extends BaseView
{	

	var $working_dir;
	var $template_dir;
	var $template_view_dir;
	var $template;
	var $errors = array();
	var $form_data = array();
	
	var $msg = array();
	var $controller;
	var $style_css;
	var $meta_title;
	
	var $category_key;
	var $category_id;
	var $entry_key;
	var $entry_id;
	var $view_key;
	
	var $home_link = false; // use home link n navigation as link 
	var $settings = array();
	
	var $nav_delim = ' / ';
	
	
	//var $view_config = array('default_1'=>'default',
	//                         'faq_1'	=>'faq_1',
	//						 'faq_2'	=>'faq_2');
	
	
	
	function KBClientView(&$controller) {

		$reg =& Registry::instance();
		$this->conf =& $reg->getEntry('conf');
		//$this->se =& $reg->getEntry('conf');
	
		$this->controller = &$controller;
		
		$this->setTemplateDir($this->controller->getSetting('view_format'), 
		                      $this->controller->getSetting('view_template'));
		
		$this->setStyleCss($this->controller->getSetting('view_format'), 
		                   $this->controller->getSetting('view_template'),
						   $this->controller->getSetting('view_style'));
		$this->setMsg();
 
		$this->category_key = $controller->getRequestKey('category_id');
		$this->category_id = $controller->getRequestVar('category_id');
		$this->entry_key = $controller->getRequestKey('entry_id');
		$this->entry_id = $controller->getRequestVar('entry_id');
		$this->view_key = $controller->getRequestKey('view');
		$this->view_id = $controller->getRequestVar('view');
		$this->msg_id = $controller->getRequestVar('msg');
	}
	
	
	function setTemplateDir($view, $template_view) {
		//$view = (isset($this->view_config[$view])) ? $this->view_config[$view] : $view;
		$this->template_dir = $this->controller->working_dir . $view . '/template/' . $template_view . '/';
	}	
	
	
	function setStyleCss($view, $template_view, $style) {
		//$view = (isset($this->view_config[$view])) ? $this->view_config[$view] : $view;
		$this->style_css = $this->controller->working_path  . $view . '/template/' . $template_view . '/' .$style . '.css';
	}
	
	
	function getMsgFile($file, $module = true) {
		require_once 'core/app/AppMsg.php';
		return ($module) ? AppMsg::getModuleMsgFile('knowledgebase', $file) 
		                 : AppMsg::getCommonMsgFile($file);
	}
	
	
	function setMsg() {
		
		$file = $this->getMsgFile('client_msg.ini');
		$this->msg = AppMsg::parseMsgs($file, false, false);
	}
	
	
	function getFormatedDate($timestamp, $format = null) {
		$format = ($format) ? $format : $this->conf['lang']['date_format'];
		return $this->_getFormatedDate($timestamp, $format);
	}	
	
	
	function getActionMsg($format = 'success') {
		
		if($this->msg_id) {
			
			require_once 'eleontev/HTML/BoxMsg.php';
			
			$file = $this->getMsgFile('client_after_action_msg.ini');
			$msgs = AppMsg::parseMsgs($file, $this->msg_id, true);
			return BoxMsg::factory($format, $msgs);
		}
	}
	
	
	// true if commentable
	function isCommentable($manager, $var = true) {
		return (bool) ($manager->getSetting('allow_comments') && $var);
	}
	
	
	// true if ratingable
	function isRatingable($manager, $var = true) {
		return (bool) ($manager->getSetting('allow_rating') && $var);
	}	
	
	
	//function isRegisteredOnly($setting) {
	
	//}
	
	
	function pageByPage($limit, $sql, $per_page = false) {
		
		require_once 'eleontev/PageByPage.php';

		$bp = new PageByPage($limit);
		
		$action_page = $this->_getLink($this->view_id, $this->category_id, $this->entry_id);		
		$bp->action_page = $action_page;
		
		$bp->setMsg($this->msg['page_msg'], $this->msg['record_msg'], $this->msg['record_from_msg']);
		$bp->countAll($sql); 
		
		return $bp;
	}	
	
	
	function setErrors($errors) { 
		$this->errors = $errors;
	}	
	
	
	function getErrors() {
		require_once 'core/app/AppMsg.php';
		return AppMsg::errorBox($this->errors, $module = false);
	}
	
	
	// use it when wronng form submission
	function setFormData(&$arr) {
		$this->form_data = &$arr;
	}
	
	
	// to popularte in form after wronng form submission
	function getFormData() {

		//$data = $this->getErrors();
		//$this->form_data['user_msg'] = $data;
		$this->form_data['required_sign'] = '<span class="requiredSign">*</span>';		
		
		return $this->form_data;
	}
	
	
	function _getItemImg($var, $category = false) {
		
		if($var) {
			$tag = '<img src="%simages/icons/lock1.gif" alt="private" width="14" height="16" title="%s">';
			$tag = sprintf($tag, $this->controller->working_path, $this->msg['login_to_view_msg']);
		} else {
			$tag = ($category) ? '<img src="%simages/icons/folder.gif" alt="" width="15" height="12">'
			                   : '<img src="%simages/icons/article.gif" alt="" width="11" height="14">';
			$tag = sprintf($tag, $this->controller->working_path);
		}

		return $tag;
	}
	
	
	function _getRating($var) {
		if($var) {
			$tag = '<img src="%simages/rating/rate_line_8px/rate_%s.gif" alt="rating">';
			$rate = sprintf($tag, $this->controller->working_path, round($var));
		} else {
			$rate = $this->msg['not_rated_msg']; 
		}
		
		return $rate;
	}
	
	
	function _getRateRange() {
		$file = $this->getMsgFile('rating_range_msg.ini');
		return AppMsg::parseMsgs($file);
	}
	
	
	function _getFormatedNavigation($arr, $article_name = false) {
		
		$arr = TreeHelperUtil::getParentsById($arr, $this->category_id, 'name');				
		
		$arr1 = array();
		if($arr || $this->home_link) {
			$page = ($this->controller->mod_rewrite) ? $this->controller->mod_rewrite_page 
			                                         : $_SERVER['PHP_SELF'];
			$str = '<a href="%s" class="navigation">%s</a>';
			$arr1[] = sprintf($str, $page, $this->controller->getSetting('nav_title'));
		} else {
			$arr1[] = sprintf('%s', $this->controller->getSetting('nav_title'));
		}
		
		// add article title if have it
		if(is_array($article_name)) {
			foreach($article_name as $k => $v) { $arr[$k] = $v; }
			$arr[] = '';
			
		} elseif($article_name !== false) {
			$arr[] = $article_name;
		}
		
		$num = count($arr); 
		$i = 1;
		foreach($arr as $k => $v) {
			if($num != $i) {
				$k = (is_numeric($k)) ? $this->_getLink(false, $k, false) : $k;
				$arr1[] = sprintf('<a href="%s" class="navigation">%s</a>',$k, $v);
			} else {
				$arr1[] = sprintf('%s', $v);
			}
			
			$i++;
		}
		
		return implode($this->nav_delim, $arr1);
	}
	
	
	function _getLink($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		return $this->controller->getLink($view, $category_id, $entry_id, $msg_key); 
	}
	
	
	function &getTop(&$manager, $article_name = false, $parse_form = true) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'top.html');
		
		// need to print msg if any
		$tpl->tplAssign('msg', $this->getActionMsg('error'));
		
		
		$c = &$manager->getCategoryModel();
		$simple_arr = &$c->getSelectRecords($manager->getSetting('category_sort_order'));
		
		$tpl->tplAssign('navigation', $this->_getFormatedNavigation($simple_arr,  $article_name));
		
		// auth info
		if($manager->is_registered) {
			$tpl->tplAssign('username', AuthMember::getUsername());
			$tpl->tplAssign('logout_link', $this->_getLink('logout'));
			$tpl->tplAssign('username_link', $this->_getLink('member'));
			$tpl->tplAssign('delim', '|');	
			
			if(AuthMember::getCookie()) { 
				$this->msg['logout_msg'] = ''; 
				$tpl->tplAssign('delim', '');	
			}
			
			$tpl->tplSetNeeded('/logged');
		
		
		} elseif($manager->isUseRegistration()) {
			
			$tpl->tplAssign('login_link',    $this->_getLink('login'));
			$tpl->tplAssign('register_link', $this->_getLink('register'));
			$tpl->tplSetNeeded('/register');
		}
		
		
		// FORM
		if($parse_form) {
			
			if($manager->getSetting('allow_post_entry')) {
				$tpl->tplSetNeededGlobal('add_entry');
				$tpl->tplAssign('add_entry_link', $this->_getLink('add_entry', $this->category_id));
			}			
			
			if($manager->getSetting('show_glossary_link')) {
				if($manager->isGlossary()) {
					$tpl->tplSetNeededGlobal('glossary');
					$tpl->tplAssign('glossary_link', $this->_getLink('glossary'));	
				}		
			}
			
			$tpl->tplSetNeeded('/form');
			

			// categories
			$select = new FormSelect();
			$select->select_tag = false;
			$select->setSelectWidth(200);
			//$select->setSelectName('category');
			$select->setRange($c->getSelectRange($simple_arr), array(0 => '____'));
			$tpl->tplAssign('category_select', $select->select($this->category_id));
			
			
			if($this->controller->mod_rewrite) {
				$tpl->tplAssign('form_action', $this->controller->mod_rewrite_page);
			}
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse($_GET);
		
		return $tpl->tplPrint(1);
	}

	
	// gey body summary
	function getSummary(&$str, $num_words) {
		
		//$search = "/<a(.*?)a>/si";
		//$replace = '';
		//$str = preg_replace($search, $replace, $str);
		
		$tags = array('<br>', '<BR>',  '< /br>', '<li>', '<p>', '<P>');
		$str = str_replace($tags, ' ', $str);

		$str = str_replace('  ', ' ', strip_tags($str));
		$str = explode(' ', $str);
		return implode(' ', array_slice($str, 0, $num_words)) . '...';
	}
	
	
	
	function _parseGlossaryItems(&$string, &$manager) {
		
		$i = 0;
		$extensions = array('.php', '.asp', '.html', '.htm', '.xml', '.jsp');
		
		$ids = array();
		$glossary = &$manager->getGlossaryItems();
		
		foreach($glossary as $id => $item) {
			if(strpos(strtolower($string), strtolower($item)) !== false) {
				$ids[] = $id;
			}
		}
		
		// have items
		if($ids) {
			
			$glossary = &$manager->getGlossaryDefinitions(implode(',', $ids));
			
			foreach($glossary as $k => $v) {
				
				$preg = "~\b($k)\b(?![^<]*>)~i";
				preg_match_all($preg, $string, $matches);
				$num = ($v['display_once']) ? 1 : count($matches[0]);
				
				for($j=0;$j<$num;$j++){
										
					$id = 'glossary_' . $i++;
					$str = "<span class=\"glossaryItem\" onClick=\"ShowGlossaryItem('%s', '%s');\" onMouseOut=\"HideGlossaryItem('%s');\">$1</span>\n
					 		<span id=\"%s\" style=\"display: none;\"></span>";
					
					$search = "~\b(".$matches[0][$j].")\b(?!<\/span>\s)(?![^<]*>)~i";					
					$replace = sprintf($str, $id, addslashes(str_replace(array("\r\n", "\n"), ' ', $v['definition'])), $id, $id);					
					$string = preg_replace($search, $replace, $string, 1);
				}
			}
		}
		
		return $string;
	}
}
?>