<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once 'eleontev/Util/CryptEmail.php';


class KBClientView_add_comment extends KBClientView_common
{


	function &execute(&$manager) {
		
		$row = &$manager->getEntryById($this->entry_id, $this->category_id);
		if(!$row) { return; }
		
		$this->meta_title = $this->msg['add_comment_msg'];
		
		$s = $this->controller->getSetting('show_title_nav');
		//$title = ($s) ? array($this->_getLink('entry', $this->category_id, $this->entry_id)=>$row['title']) : '';
		$title = ($s) ? $row['title'] : '';
		
		$data = $this->getTop($manager, $title, false);
		$data .= $this->getForm($manager);
		$data .= $this->getEntry($manager, $row);
		
		return $data;		
	}
	
	
	
	function getEntry(&$manager, &$row)  {
		$tpl = &new tplTemplatez($this->template_dir . 'article.html');
		$tpl->tplParse(array_merge($row, $this->msg));
		return $tpl->tplPrint(1);
	}
	
 
	function getForm($manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'comment_form.html');
		
		$tpl->tplSetNeeded('/cancel_btn');
		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('cancel_link', $this->_getLink('entry', $this->category_id, $this->entry_id));															  
		
		$tpl->tplAssign('user_msg', $this->getErrors());
		
		if(!$manager->is_registered) {
			$tpl->tplSetNeeded('/not_registered');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($this->getFormData());	
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function validate($values) {
		
		require_once 'eleontev/Validator.php';
		
		$v =& new Validator($values, true);
		$v->requiredArray('required_msg', array('comment'));
		
		if(isset($values['email'])) {
			$v->regex('email_msg', 'email', 'email', false);
		}
				
		return $v->getErrors();
	}
}
?>