<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientView_login extends KBClientView_common
{
	

	function &execute(&$manager) {
		
		$file = $this->getMsgFile('user_msg.ini', false);
		$this->msg = array_merge($this->msg, AppMsg::parseMsgs($file));
		
		$this->home_link = true;
		$this->meta_title = $this->msg['login_msg'];
		
		$data = $this->getTop($manager, $this->msg['login_msg'], false);
		$data .= $this->getForm();
		
		return $data;		
	}
	

	function getForm() {
		
		$tpl = &new tplTemplatez($this->template_dir . 'login_form.html');
		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('forgot_password_link', $this->_getLink('password'));
		$tpl->tplAssign('register_link', $this->_getLink('register'));
		
		$view = ($this->category_id) ? 'entry' : false;		
		$tpl->tplAssign('cancel_link', $this->_getLink($view, $this->category_id, $this->entry_id));		
		
		$tpl->tplAssign('user_msg', $this->getErrors());
		
		$tpl->tplParse(array_merge($this->msg, $this->getFormData()));
		return $tpl->tplPrint(1);
	}
	
	
	function validate($values, $manager) {
		
		require_once 'eleontev/Validator.php';
		
		$v =& new Validator($values, false);
		$v->requiredArray('required_msg', array('username', 'password'));
		if($v->getErrors()) {
			return $v->getErrors();
		}
		
		
		$auth = &new AuthMember();
		$auth->tbl->table = $manager->tbl->user;
		$ret = $auth->doAuth($values['username'], $values['password'], $values['remember']);
		
		if($ret == false) {
			$v->setError('wrong_login_info_msg', 1);			
		}
		
		return $v->getErrors();
	}
}
?>