<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once 'eleontev/PageByPage.php';


class KBClientView_search extends KBClientView_common
{
	

	function &execute(&$manager) {
		
		$this->home_link = true;
		$this->meta_title = '';

		$data = $this->getTop($manager);
		$data .= $this->getEntryList($manager);
		return $data;	
	}
	
	
	function getEntryList(&$manager) {
		
			
		$search = $manager->getFullSearchParams();
		$manager->setSqlParams('AND ' . $search['where']);
		$manager->sql_params_select = $search['select'];
		$manager->sql_params_order =  $search['order'];
	

		$bp = new PageByPage($manager->getSetting('num_entries_per_page'), $_GET);	
		$bp->setMsg($this->msg['page_msg'], $this->msg['record_msg'], $this->msg['record_from_msg']);
		$bp->countAll($manager->getEntryCountSql()); 		
		
		
		$rows = &$manager->getEntryList($bp->limit, $bp->offset);
		return $this->_parseArticleList($manager, $rows, $bp->shortNavigate());
	}
	
	
	// parse data with articles
	function &_parseArticleList(&$manager, &$rows, $by_page) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'search_result_list.html');
		
		if(!$rows) {
		
			require_once 'eleontev/HTML/BoxMsg.php';
		
			$msg = new BoxMsg();
			$msg->setMsg('body', $this->msg['no_search_result_msg']);
		
			$tpl->tplAssign('msg', $msg->get());
		
		} else {
		
			foreach($rows as $k => $row) {
				
				$tpl->tplAssign('item_img', $this->_getItemImg($row['category_private']));
				$tpl->tplAssign('updated_date', $this->getFormatedDate($row['ts_updated']));
				$tpl->tplAssign('entry_link', $this->_getLink('entry', $row['category_id'], $row['id']));
	
				$row['title'] = (strrpos($row['title'], '?')) ? $row['title'] : $row['title'] . '?';
				$row['body'] = $this->getSummary($row['body'], 20); 
				
				
				if($manager->getSetting('show_hits')) {
					$tpl->tplSetNeeded('row/show_hits');
				}
				
				
				if($this->isRatingable($manager, $row['ratingable'])) {
					$tpl->tplAssign('rating', $this->_getRating($row['rating']));
				} else {
					$tpl->tplAssign('rating', '');
				}	
				
				
				if($this->isCommentable($manager, $row['commentable'])) {
					$tpl->tplSetNeeded('row/show_comments');
				}			
				
				$tpl->tplParse(array_merge($row, $this->msg), 'row');
			} 	
		}
	
		$tpl->tplAssign('page_by_page', $by_page);
		$tpl->tplAssign('search_result_msg', $this->msg['search_result_msg']);	

		$tpl->tplParse();
		
		return $tpl->tplPrint(1);
	}
}
?>